// bgsviewView.cpp : CBgsviewView NX̓̒`s܂B
//

#include "stdafx.h"
#include "bgsview.h"

#include "bgsviewDoc.h"
#include "bgsviewView.h"
#include "mainfrm.h"
#include "conv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBgsviewView

IMPLEMENT_DYNCREATE(CBgsviewView, CView)

BEGIN_MESSAGE_MAP(CBgsviewView, CView)
	//{{AFX_MSG_MAP(CBgsviewView)
	ON_UPDATE_COMMAND_UI(ID_ZOOM, OnUpdateZoom)
	ON_COMMAND(ID_ZOOM, OnZoom)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBgsviewView NX̍\z/

CBgsviewView::CBgsviewView()
{
	m_MeterPerPixel = 1000.0;	// 1km / pixel
	m_zoomMode = TRUE;

	m_orgLat = m_orgLon = 0.0;
}

CBgsviewView::~CBgsviewView()
{
}

BOOL CBgsviewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//       CĂB

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBgsviewView NX̕`

void CBgsviewView::OnDraw(CDC* pDC)
{
	CBgsviewDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->DrawAll(pDC, m_orgLat, m_orgLon, m_MeterPerPixel);
}

/////////////////////////////////////////////////////////////////////////////
// CBgsviewView NẌ

BOOL CBgsviewView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CBgsviewView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CBgsviewView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CBgsviewView NX̐ff

#ifdef _DEBUG
void CBgsviewView::AssertValid() const
{
	CView::AssertValid();
}

void CBgsviewView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBgsviewDoc* CBgsviewView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBgsviewDoc)));
	return (CBgsviewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBgsviewView NX̃bZ[W nh


void CBgsviewView::OnInitialUpdate() 
{
	CBgsviewDoc *pDoc = GetDocument();
	
	pDoc->GetInitialOrgLatLon(&m_orgLat, &m_orgLon);
	
	CView::OnInitialUpdate();
}

void CBgsviewView::OnZoom() 
{
/*	CZoomDialog	dlg;

	dlg.m_MeterPerPixel = m_MeterPerPixel;
	if (dlg.DoModal() == IDOK) {
		m_MeterPerPixel = dlg.m_MeterPerPixel;

		GetDocument()->UpdateAllViews(NULL);
	}*/
	m_zoomMode = !m_zoomMode;
}

void CBgsviewView::OnUpdateZoom(CCmdUI* pCmdUI) 
{
	if (m_zoomMode) {
		pCmdUI->SetCheck(1);
	} else {
		pCmdUI->SetCheck(0);
	}
}

void CBgsviewView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_zoomMode) {
		double newMeterPerPixel = m_MeterPerPixel;
		if (m_MeterPerPixel > 0.1) {
			newMeterPerPixel /= 2;
		}
		MoveCenter(point, newMeterPerPixel);
	}
	else {
		SelRefPoint(point);
	}

	CView::OnLButtonDown(nFlags, point);
}

void CBgsviewView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if (m_zoomMode) {
		double newMeterPerPixel = m_MeterPerPixel;
		if (m_MeterPerPixel < 10000 ) {
			newMeterPerPixel *= 2;
		}
		MoveCenter(point, newMeterPerPixel);
	}	
	else {
		//SelRefPoint(point);
		MoveCenter(point, m_MeterPerPixel);
	}
	
	CView::OnRButtonDown(nFlags, point);
}

void CBgsviewView::MoveCenter(CPoint point, double newMeterPerPixel)
{
	// NbNʒüܓxoxvZ
	double centLat, centLon;
	CalcLatLon(m_orgLat, m_orgLon,
		- point.y * m_MeterPerPixel, point.x * m_MeterPerPixel,
		&centLat, &centLon);

	// ʍ̈ܓxoxvZ
	RECT rect;
	GetClientRect(&rect);
	
	int cx = rect.right / 2;
	int cy = rect.bottom / 2;

	CalcLatLon(centLat, centLon,
		cy * newMeterPerPixel, - cx * newMeterPerPixel,
		&m_orgLat, &m_orgLon);
	
	m_MeterPerPixel = newMeterPerPixel;
	
	Invalidate();
}

// IuWFNg̑I
void CBgsviewView::SelRefPoint(CPoint point)
{
	// NbNʒüܓxoxvZ
	double clickedLat, clickedLon;
	CalcLatLon(m_orgLat, m_orgLon,
		- point.y * m_MeterPerPixel, point.x * m_MeterPerPixel,
		&clickedLat, &clickedLon);

	CBgsviewDoc* pDoc = GetDocument();
	pDoc->SelRefPoint(clickedLat, clickedLon);

	Invalidate();
}

void CBgsviewView::OnMouseMove(UINT nFlags, CPoint point) 
{
	static double lat, lon;
	static CString latstr, lonstr;

	// }EXʒüܓxoxvZ
	CalcLatLon(m_orgLat, m_orgLon,
		- point.y * m_MeterPerPixel, point.x * m_MeterPerPixel,
		&lat, &lon);

	// ɕϊ
	latstr = rad2degs(lat, TRUE);
	lonstr = rad2degs(lon, FALSE);

	((CMainFrame *)AfxGetMainWnd())->SetLatLonStatus(latstr, lonstr);

	CView::OnMouseMove(nFlags, point);
}


