// conv.cpp
#include "stdafx.h"
#include "conv.h"
#include <string.h>
#include <math.h>

// ##d##m##.##s -> pxϊ
// ͔̕j󂳂B
double degs2rad(const char *str)
{
	char *p;
	int dd, mm;
	double ss;
	dd = mm = 0;
	ss = 0.0;
	BOOL reverse = FALSE;

	if (*str == 'S' || *str == 'W') reverse = TRUE;
	str++;

	p = strchr(str, 'd');
	if (p == NULL) goto end;
	*p = '\0';
	dd = atoi(str);
	str = p + 1;

	p = strchr(str, 'm');
	if (p == NULL) goto end;
	*p = '\0';
	mm = atoi(str);
	str = p + 1;

	p = strchr(str, 's');
	if (p == NULL) goto end;
	*p = '\0';
	ss = atof(str);

end:
	double rad = ((double)dd + (double)mm / 60.0 + (double)ss / 3600.0)
		* PI / 180.0;
	if (reverse) rad = -rad;
	return rad;
}

CString rad2degs(double rad, BOOL latflag)
{
	double deg = rad * 180.0 / PI;
	BOOL reverse = FALSE;

	if (deg < 0) {
		deg = -deg;
		reverse = TRUE;
	}

	int dd = (int)deg;
	deg = (deg - dd) * 60.0;
	int mm = (int)deg;
	double ss = (deg - mm) * 60.0;

	CString degstr;
	char *str = degstr.GetBuffer(20);

	char prefix;
	if (latflag) {
		if (!reverse) {
			prefix = 'N';
		} else {
			prefix = 'S';
		}
	} else {
		if (!reverse) {
			prefix = 'E';
		} else {
			prefix = 'W';
		}
	}

	sprintf(str, "%c%dd%dm%.3fs", prefix, dd, mm, ss);
	degstr.ReleaseBuffer();

	return degstr;
}

void CalcLatLon(double reflat, double reflon,
		double yy, double xx,
		double *lat, double *lon)
{
	*lat = reflat + yy / ER;
	*lon = reflon + xx / ER / cos(reflat);
}

void CalcOffset(double reflat, double reflon,
		double lat, double lon,
		double *yy, double *xx)
{
	*yy = (lat - reflat) * ER;
	*xx = (lon - reflon) * ER * cos(reflat);
}
